/* ------------------------------------------------------------------------- *
 * 抵抗膜式タッチパネル  Arduino UNO用サンプルスケッチ                       *
 * Copyright (C) 2021-2022 KYOHRITSU ELECTRONIC INDUSTRY CO., LTD.           *
 *     https://prod.kyohritsu.com/KP-TPCONV.html                             *
 * 本プログラムは無保証にて配布いたします。プログラムの内容に関するご質問へ  *
 * の回答・サポート等は行っておりません。                                    *
 * ご理解の上、参考目的としてご利用ください。                                *
 * ------------------------------------------------------------------------- */

int PanelXL = A3;
int PanelXR = A2;
int PanelYU = A1;
int PanelYD = A0;

bool readPanel(int *X, int *Y) {
  int valX, valXa, valY, valYa;
  static bool tce = false;

  //タッチチェック
  if (digitalRead(PanelXL) == 0) { //タッチON
    if (tce == false) { //今回始めて検出
      delay(10); //チャタリングキャンセル
      if (digitalRead(PanelXL) == 0) tce = true;
    }
  } else {
    tce = false;
  }

  if (tce) { //タッチ検出
    //Xスキャン
    pinMode(PanelYU, INPUT);
    pinMode(PanelYD, INPUT);
    pinMode(PanelXL, OUTPUT);
    pinMode(PanelXR, OUTPUT);
    digitalWrite(PanelXL, LOW);
    digitalWrite(PanelXR, HIGH);
    delayMicroseconds(5);
    valX = analogRead(PanelYD);
    digitalWrite(PanelXL, HIGH);
    digitalWrite(PanelXR, LOW);
    delayMicroseconds(5);
    valXa = 1023 - analogRead(PanelYD);
    //Yスキャン
    pinMode(PanelXL, INPUT);
    pinMode(PanelXR, INPUT);
    pinMode(PanelYU, OUTPUT);
    pinMode(PanelYD, OUTPUT);
    digitalWrite(PanelYD, LOW);
    digitalWrite(PanelYU, HIGH);
    delayMicroseconds(5);
    valY = analogRead(PanelXL);
    digitalWrite(PanelYD, HIGH);
    digitalWrite(PanelYU, LOW);
    delayMicroseconds(5);
    valYa = 1023 - analogRead(PanelXL);
    *X = (valX + valXa) >> 1;
    *Y = (valY + valYa) >> 1;
  } else {
    *X = 0;
    *Y = 0;
  }

  //後始末
  pinMode(PanelXL, INPUT_PULLUP);
  pinMode(PanelXR, INPUT);
  pinMode(PanelYU, OUTPUT);
  pinMode(PanelYD, OUTPUT);
  digitalWrite(PanelYU, LOW);
  digitalWrite(PanelYD, LOW);
  return tce;//タッチ判別を戻す
}

void setup() {
  Serial.begin(9600);
  while (!Serial);
  readPanel(NULL, NULL); //初期化用ダミーリード
}

void loop() {
  int Xpos, Ypos;
  bool touch;

  touch = readPanel(&Xpos, &Ypos);
  if (touch) {
    Serial.print(Xpos);
    Serial.print(',');
    Serial.println(Ypos);
  }
  delay(50);
}
